#!/usr/local/bin/perl -w --

# This perl file is read by vchat.cc and contains helper functions
# called by vchat during the chat conversation.

# sub serverMessage

# Reformat one or more chat server messages.  The message(s) are
# passed in as one string in protocol format (see protocol.doc).  The
# routine should return the reformatted messages(s).  Note that
# vchat.cc will perform simple interpretations on every returned line
# beginning with three digits.  All other lines are put to the user's
# screen verbatim.

sub serverMessage {
    my $message = shift;

    my $retval = "";

    foreach (split(/\n/, $message)) {

	if (/^211 (\S+)/) {
	    $retval .= "* $1 joined the chat\r\n";

	} elsif (/^221 (\S+).*\((.*)\)/) {
	    my $reason = "";
	    if ($2 ne "") {
		$reason = " ($2)";
	    }
	    $retval .= "* $1 left the chat$reason\r\n";

	} elsif (/^241 (\S+) (\S+)/) {
	    $retval .= "* $1 changed his nick to $2\r\n";

	} else {
	    $retval .= $_ . "\n";
	}
    }

    return $retval;
}
